Subject: Re: bug#28623: 27.0.50; lisp/progmodes/cc-engine.el incorrect indentation of C++14 curly-brace initializer list

From: Alan Mackenzie <[email-masked]>
Date: Wed, 4 Oct 2017 18:15:53 +0000

Hello, Tadeus.

On Wed, Sep 27, 2017 at 19:49:57 +0200, Tadeus Prastowo wrote:
> The following C++14 source code, which is also attached as `mwe.cpp',
> shows the indentation problem:

> --8<------------------------------
> #include <vector>
> #include <iostream>

> static std::vector<std::vector<unsigned>>
> fn(std::vector<std::vector<unsigned>> data) {
>   return {
>           {1, 2, 3},
>           {4, 5, 6},
>           {7, 8, 9},
>   };
> }

> static std::vector<std::vector<unsigned>>
> fn(unsigned n, std::vector<std::vector<unsigned>> data) {
>   return {
>           {n + 1, n + 2, n + 3},
>           {n + 4, n + 5, n + 6},
>           {n + 7, n + 8, n + 9},
>   };
> }

> int main() {
>   /* Expected indentation */
>   fn({
>       {1, 2, 3},
>       {3, 4, 5},
>       {6, 7, 8},
>     });
>   for (const auto &v : fn({
>                            {3, 4, 5},
>                            {6, 7, 8},
>                            {9, 10, 11},
>       })) {
>     for (const auto &a : v) {
>       std::cout << a << '\n';
>     }
>   }
>   /* End: Expected indentation */

>   /* Problem */
>   fn(20, {
>       {1, 2, 3},
>         {3, 4, 5},
>           {6, 7, 8},
>             });
>   for (const auto &v : fn(20, {
>         {3, 4, 5},
>           {6, 7, 8},
>             {9, 10, 11},
>               })) {
>     for (const auto &a : v) {
>       std::cout << a << '\n';
>     }
>   }
>   /* End: Problem */
> }
> --8<------------------------------

Yes.

> To fix the problem, I make the following patch:
> --8<------------------------------
> diff --git a/lisp/progmodes/cc-engine.el b/lisp/progmodes/cc-engine.el
> index 05b391a..077e9c9 100644
> --- a/lisp/progmodes/cc-engine.el
> +++ b/lisp/progmodes/cc-engine.el
> @@ -10387,6 +10387,7 @@ comment at the start of cc-engine.el for more info."
>                (eq (char-after) ?\())
>           (setq braceassignp 'c++-noassign))
>          ((looking-at c-pre-id-bracelist-key))
> +        ((looking-at ",\\s *"))
>          ((looking-at c-return-key))
>          ((and (looking-at c-symbol-start)
>                (not (looking-at c-keywords-regexp)))
> @@ -10398,6 +10399,7 @@ comment at the start of cc-engine.el for more info."
>             (and (c-go-up-list-backward nil lim) ; FIXME!!! Check
> `lim' 2016-07-12.
>              (eq (char-after) ?\()))
>            ((looking-at c-pre-id-bracelist-key))
> +          ((looking-at ",\\s *"))
>            ((looking-at c-return-key))
>            (t (setq after-type-id-pos (point))
>               nil))))
> --8<------------------------------

> Any better suggestion as to how to fix the problem?

Hey, I just love it when people diagnose and fix their own bugs,
particularly in some of the more involved bits of CC Mode.  :-)

Just one tiny, tiny, nitpick.  in (looking-at ",\\s *"), isn't the "any
amount of space" bit redundant, since we don't use match-end to get the
precise position?  In fact, I'm tending towards the simpler (eq
(char-after) ?,).

But, as I say, that's a tiny point in a great piece of debugging.  I
will commit this (to the Emacs-26 branch of savannah) soon (from where
it will find its way to the master branch due to some public spirited
person who arranges these things).

Many thanks!

> Thanks.

> In GNU Emacs 27.0.50 (build 2, x86_64-pc-linux-gnu, GTK+ Version 3.18.9)
>  of 2017-09-27 built on lgw01-amd64-052
> Windowing system distributor 'The X.Org Foundation', version 11.0.11804000
> System Description:    Ubuntu 16.04.3 LTS

[ .... ]

> Major mode: C++//l

[ .... ]

> --
> Best regards,
> Tadeus

-- 
Alan Mackenzie (Nuremberg, Germany).